// PIC24FJ64GA002 (28Pin DIP)
// RP0 - RP15sɋ@\t܂ (rev1.0)
// 2007.9.20 by 

#include "p24FJ64GA002.h"
#include "pinsel.h"  //for PinSel (p24FJ64GAincludeɒuĂ)

// InPinSel() : input function      OutPinSel() : output function
// func                             func
// IFNC_INT1                         OFNC_NULL
// IFNC_INT2                         OFNC_C1OUT
// IFNC_INT3                         OFNC_C2OUT
// IFNC_INT4                         OFNC_U1TX
// IFNC_T2CK                         OFNC_U1RTS
// IFNC_T3CK                         OFNC_U2TX
// IFNC_T4CK                         OFNC_U2RTS
// IFNC_T5CK                         OFNC_SDO1
// IFNC_IC1                          OFNC_SCK1OUT
// IFNC_IC2                          OFNC_SS1OUT
// IFNC_IC3                          OFNC_SDO2
// IFNC_IC4                          OFNC_SCK2OUT
// IFNC_IC5                          OFNC_SS2OUT
// IFNC_OCFA                         OFNC_CC1
// IFNC_OCFB                         OFNC_CC2
// IFNC_U1RX                         OFNC_CC3
// IFNC_U1CTS                        OFNC_CC4
// IFNC_U2RX                         OFNC_CC5
// IFNC_U2CTS
// IFNC_SDI1
// IFNC_SCK1
// IFNC_SS1
// IFNC_SDI2
// IFNC_SCK2
// IFNC_SS2
//

// rpno
//
// PIN_RP0
// PIN_RP1
// PIN_RP2
// PIN_RP3
// PIN_RP4
// PIN_RP5
// PIN_RP6
// PIN_RP7
// PIN_RP8
// PIN_RP9
// PIN_RP10
// PIN_RP11
// PIN_RP12
// PIN_RP13
// PIN_RP14
// PIN_RP15

void InPinSel(int func, int rpno)
{
    switch(func)
    {
        case IFNC_INT1: RPINR0bits.INT1R = rpno; break;
        case IFNC_INT2: RPINR1bits.INT2R = rpno; break;
        case IFNC_T2CK: RPINR3bits.T2CKR = rpno; break;
        case IFNC_T3CK: RPINR3bits.T3CKR = rpno; break;
        case IFNC_T4CK: RPINR4bits.T4CKR = rpno; break;
        case IFNC_T5CK: RPINR4bits.T5CKR = rpno; break;
        case IFNC_IC1:  RPINR7bits.IC1R = rpno; break;
        case IFNC_IC2:  RPINR7bits.IC2R = rpno; break;
        case IFNC_IC3:  RPINR8bits.IC3R = rpno; break;
        case IFNC_IC4:  RPINR8bits.IC4R = rpno; break;
        case IFNC_IC5:  RPINR9bits.IC5R = rpno; break;
        case IFNC_OCFA: RPINR11bits.OCFAR  = rpno; break;
        case IFNC_OCFB: RPINR11bits.OCFBR  = rpno; break;
        case IFNC_U1RX: RPINR18bits.U1RXR  = rpno; break;
        case IFNC_U1CTS:RPINR18bits.U1CTSR = rpno; break;
        case IFNC_U2RX: RPINR19bits.U2RXR  = rpno; break;
        case IFNC_U2CTS:RPINR19bits.U2CTSR = rpno; break;
        case IFNC_SDI1: RPINR20bits.SDI1R  = rpno; break;
        case IFNC_SCK1: RPINR20bits.SCK1R = rpno; break;
        case IFNC_SS1:  RPINR21bits.SS1R  = rpno; break;
        case IFNC_SDI2: RPINR22bits.SDI2R = rpno; break;
        case IFNC_SCK2: RPINR22bits.SCK2R = rpno; break;
        case IFNC_SS2:  RPINR23bits.SS2R  = rpno; break;
    }
}

void OutPinSel(int func, int rpno)
{
    switch(rpno)
    {
        case 0: RPOR0bits.RP0R = func; break;
        case 1: RPOR0bits.RP1R = func; break;
        case 2: RPOR1bits.RP2R = func; break;
        case 3: RPOR1bits.RP3R = func; break;
        case 4: RPOR2bits.RP4R = func; break;
        case 5: RPOR2bits.RP5R = func; break;
        case 6: RPOR3bits.RP6R = func; break;
        case 7: RPOR3bits.RP7R = func; break;
        case 8: RPOR4bits.RP8R = func; break;
        case 9: RPOR4bits.RP9R = func; break;
        case 10: RPOR5bits.RP10R = func; break;
        case 11: RPOR5bits.RP11R = func; break;
        case 12: RPOR6bits.RP12R = func; break;
        case 13: RPOR6bits.RP13R = func; break;
        case 14: RPOR7bits.RP14R = func; break;
        case 15: RPOR7bits.RP15R = func; break;
    }
}
