//PIC24FJ64GA002 8MHz internal/externl clock (PLL=32MHz)
//HtSC1602ɂRTC eXgvO@UARTݒt
//2007.9.30  
//
//PICRTC,UART1gp
//
//FMPLAB IDE v7.62
//RpCFC30 v3.01 (19 June 2007)
//C^[FPICkit2 v2.40
//
//RpCœK:
//MPLAB C30t PIC24FCugp:libpPIC24Fxxx-coff.a
//
//Fjo[T
//            HtSC1602
//PORTB 15 -  DB7
//PORTB 14 -  DB6
//PORTB 13 -  DB5
//PORTB 12 -  DB4
//PORTB 11 -  E
//PORTB 10 -  RS
//            R/WGND
//
//PORTB 6  - LED
//
//OSCI     - Uq8MHz (22pF)
//OSCO     - 
//SOSCI    - Uq32.768KHz (22pF)
//SOSCO    - 
//
//RP0 - UART1 TX (PGD1Ƌ) PICkit2̂t`qs sgĒʐM
//RP1 - UART1 RX (PGC1Ƌ) PICkit2̂t`qs sgĒʐM
//

//C30 include
#define USE_AND_OR     //CuORgp(C30CũCN[ht@COɒu)

#include "p24FJ64GA002.h"
#include "stdio.h"
#include "string.h"
#include "rtcc.h"

//My include
#include "EasyUart.h"
#include "PinSel.h"
#include "lcd.h"

extern int delay_cycle(unsigned int n);
extern int delay_msec(unsigned int n, unsigned int m);
extern void MakeYoubi();

#define F_CPU           32000000UL  //CNbNg 32MHz

char Calibration = 0;

//CONFIG͂ohbetm̂̂Qlɂ܂
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & ICS_PGx1 & FWDTEN_OFF )

//CARC̏ꍇ (PLL x 4 = 32MHz)
//_CONFIG2(IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_NONE)

//C4-8MHz (PLLx4 = 16-32MHz)
_CONFIG2(IESO_OFF & FNOSC_PRIPLL & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_HS)

//C10-32MHz (PLL Ȃ)
//_CONFIG2(IESO_OFF & FNOSC_PRI & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_HS)

void delay_ms(unsigned int ms)
{
    #define one_loop_cycle 1UL //one loop = 1 cycle
    #define clock_per_cycle 2UL // clock / cycle  (PTCNQNbNĂHH)
    #define delay_1msec_wk ((F_CPU/1000UL) / (one_loop_cycle*clock_per_cycle))
    #define delay_1msec_val (delay_1msec_wk-5UL) //-5UL͎ԕ␳l
    
    delay_msec(delay_1msec_val, ms);
}

//jvZ(y,m,dBCD)
//youbi = 0:A1:A2:΁A3:A4:؁A5:A6:y
int CalcYoubi(int y, int m, int d)
{
    int youbi;

    y = (y/16)*10 + (y & 0xf);//BCD to BIN
    m = (m/16)*10 + (m & 0xf);//BCD to BIN
    d = (d/16)*10 + (d & 0xf);//BCD to BIN

    if (m==1 || m==2) {
        y--;
        m+=12;
    }
    youbi = (y + y/4 - y/100 + y/400 + (13*m+8)/5 + d) % 7;//jvZ

    return(youbi);
}

void DateSetSub(rtccDate *RtccDate)
{
    int ch, i;
    int y, m, d, youbi;
    char str[128], din[20];

    for(i=0;i<sizeof(din);i++) din[i]=0;

    while(1)
    {
        Uart1PutStr("\xd\xa");
        sprintf(str, "Input Date format : year 20xx.month.day  xx.xx.xx=?");
        Uart1PutStr(str);

        while(Uart1GetChar()!=-1);//ݍ폜

        i=0;
        while(1)
        {
            while((ch=Uart1GetChar())==-1);
            if('0'<=ch && ch<='9')
            {
                din[i]=ch&0xff;
                i++;
                sprintf(str, "%c", ch);
                Uart1PutStr(str);
                if((i%3)==2 && i<8)
                {
                    Uart1PutChar('.');
                    din[i++]='.';
                }
            }
            if(i>=9) break;
            if(ch==0xd) break;//return key
        }
        if(ch==0xd && i==8) break;//return key
    }

    Uart1PutStr("\xd\xa");
    sprintf(str,"%s\xd\xa", din);
    Uart1PutStr(str);

    sscanf(str,"%x.%x.%x", &y, &m, &d);//BCD

    youbi = CalcYoubi(y, m, d);//jvZ

    RtccDate->f.year = y;
    RtccDate->f.mon = m;
    RtccDate->f.mday = d;
    RtccDate->f.wday = youbi;

    Uart1PutStr("Date Set End\xd\xa");
    Uart1PutStr("\xd\xa");
}

void TimeSetSub(rtccTime *RtccTime)
{
    int ch, i, h, m, s;
    char str[128], din[20];

    for(i=0;i<sizeof(din);i++) din[i]=0;

    while(1)
    {
        Uart1PutStr("\xd\xa");
        sprintf(str, "Input Time format : hour.min.sec  xx.xx.xx=?");
        Uart1PutStr(str);

        while(Uart1GetChar()!=-1);//ݍ폜

        i=0;
        while(1)
        {
            while((ch=Uart1GetChar())==-1);
            if('0'<=ch && ch<='9')
            {
                din[i]=ch&0xff;
                i++;
                sprintf(str, "%c", ch);
                Uart1PutStr(str);
                if((i%3)==2 && i<8)
                {
                    Uart1PutChar('.');
                    din[i++]='.';
                }
            }
            if(i>=9) break;
            if(ch==0xd) break;//return key
        }
        if(ch==0xd && i==8) break;//return key
    }

    Uart1PutStr("\xd\xa");
    sprintf(str,"%s\xd\xa", din);
    Uart1PutStr(str);

    sscanf(str,"%x.%x.%x", &h, &m, &s);

    RtccTime->f.hour = h;
    RtccTime->f.min = m;
    RtccTime->f.sec = s;

    Uart1PutStr("Time Set End\xd\xa");
    Uart1PutStr("\xd\xa");
}

void DareTimeSet(int sel)
{
    char str[128];
    rtccTime RtccTime;
    rtccDate RtccDate;

    RtccReadDate(&RtccDate);
    RtccReadTime(&RtccTime);

    lcd_cls();//tʃNA
    lcd_putstr("DATE&TIME SET");

    Uart1PutStr("DATE&TIME SET\xd\xa");

    sprintf(str, "Date=20%02x.%02x.%02x\xd\xa", 
            RtccDate.f.year, RtccDate.f.mon, RtccDate.f.mday);
    Uart1PutStr(str);

    sprintf(str, "Time=%02x:%02x.%02x\xd\xa", 
            RtccTime.f.hour, RtccTime.f.min, RtccTime.f.sec);
    Uart1PutStr(str);

    if(sel=='T' || sel=='t') TimeSetSub(&RtccTime);
    if(sel=='D' || sel=='d') DateSetSub(&RtccDate);

    RtccWrOn();            //RCFGCAL=1, RTCWREN=1
    if(sel=='D' || sel=='d')
    {
        RtccWriteDate(&RtccDate, TRUE);//t̐ݒ
    }
    if(sel=='T' || sel=='t')
    {    
        RtccWriteTime(&RtccTime, TRUE);//Ԃ̐ݒ
    }
    RtccSetCalibration(Calibration);
    mRtccOn();//RCFGCAL=1, RTCEN=1, RTCWREN=0, RTCSYNC=0, HALFSEC=0, RTCOE=0, ALCFGRPT=0

    while(Uart1GetChar()!=-1);//ݍ폜
}

int main()
{
    char str[17];//LCD\p
    int youbi;//j̒l
    int ch;//UART char

    rtccTime RtccTime;
    rtccDate RtccDate;
    rtccTime RtccTimeNew;
    rtccDate RtccDateNew;

    _RCDIV = 0;//PostScaler   ( 0 : 32MHz   1 : 16MHz )

    AD1PCFG = 0xffff;//SAiOsneeAfW^sɂ܂
    TRISBbits.TRISB6 = 0;//RB6 Output LED
    TRISBbits.TRISB0 = 0;//RP0 Output TX
    TRISBbits.TRISB1 = 1;//RP1 Input RX

    OutPinSel(OFNC_U1TX, PIN_RP0);//RP0(Pin4) UART1 TXɊt (ICSP PGD1Ƌ)
    InPinSel(IFNC_U1RX, PIN_RP1);//RP1(Pin5) UART1 RXɊt (ICSP PGC1Ƌ)

    //UART
    Uart1Init((F_CPU>>1), 9600);//{[[g38400bpsA8bitANoParityAStopBit1
    while(Uart1GetChar()!=-1);//ݍ폜

    //t
    lcd_init();//|[g̏̒łȂĂ܂
    lcd_cls();//tʃNA
    MakeYoubi();//j̃LN^[Zbg
    lcd_gotopos(0,0);//x=0, line=0
    lcd_putstr("Date Time Set");
    lcd_gotopos(0,1);//x=0, line=1
    lcd_putstr("Send D or T");
    delay_ms(5000);
    lcd_cls();//tʃNA
    lcd_gotopos(0,0);//x=0, line=0
    lcd_putstr("UART1");
    lcd_gotopos(0,1);//x=0, line=1
    lcd_putstr("9600,8,pn,s1");
    delay_ms(5000);

    //RTC
    RtccInitClock();       //sets the RTCC Off and disables RTCC write. Disables the OE.
    RtccWrOn();            //RCFGCAL=1, RTCWREN=1

    RtccDate.f.year = 0x07;//BCD 00-99
    RtccDate.f.mon  = 0x09;//BCD 01-12
    RtccDate.f.mday = 0x29;//BCD 01-31
    youbi = CalcYoubi(RtccDate.f.year, RtccDate.f.mon, RtccDate.f.mday);//jvZ
    RtccDate.f.wday = youbi;//BCD 00-06 (0:A1:A2:΁A3:A4:؁A5:A6:y)
    RtccWriteDate(&RtccDate, TRUE);//t̐ݒ

    RtccTime.f.hour = 0x10;//BCD 00-23
    RtccTime.f.min  = 0x10;//BCD 00-59
    RtccTime.f.sec  = 0x00;//BCD 00-59
    RtccWriteTime(&RtccTime, TRUE);//Ԃ̐ݒ

    RtccSetCalibration(Calibration);

    mRtccOn();//RCFGCAL=1, RTCEN=1, RTCWREN=0, RTCSYNC=0, HALFSEC=0, RTCOE=0, ALCFGRPT=0

    while(1){
        ch = Uart1GetChar();
        if(ch=='T' || ch=='t' || ch=='D' || ch=='d')    DareTimeSet(ch);

        mRtccWaitSync();//read or write sync

        //Ԏ擾
        RtccReadTime(&RtccTimeNew);

        //t擾
        RtccReadDate(&RtccDateNew);

        if(RtccTimeNew.f.sec != RtccTime.f.sec)
        {
            PORTBbits.RB6 = 1;//LED

            //t\
            lcd_gotopos(0,0);//x=0, line=0
            youbi = RtccDateNew.f.wday;
            sprintf(str, "20%02x%c %02x%c%02x",
                RtccDateNew.f.year, 7, RtccDateNew.f.mon, 1, RtccDateNew.f.mday);
            lcd_putstr(str);
            lcd_putch(0);//""
            lcd_putch('(');
            lcd_putch(youbi);//j
            lcd_putch(')');

            //\
            lcd_gotopos(0,1);//x=0, line=1
            sprintf(str, "clock %02x:%02x.%02x",
                RtccTimeNew.f.hour, RtccTimeNew.f.min, RtccTimeNew.f.sec);
            lcd_putstr(str);

            RtccDate = RtccDateNew;//update
            RtccTime = RtccTimeNew;//update

            PORTBbits.RB6 = 0;//LED_
        }
    }

    return 1;
}


